import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _construct from "@babel/runtime/helpers/esm/construct";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import classnames from 'classnames';
import CodeMirror from '@uiw/react-codemirror';
import copyTextToClipboard from '@uiw/copy-to-clipboard';
import Split from '@uiw/react-split';
import CodePen from './CodePen';
import icon from './icon';
import { BabelTransform } from './transform';
import './monokai.css';
import "./index.css";

var CodePreview =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(CodePreview, _React$PureComponent);

  var _super = _createSuper(CodePreview);

  function CodePreview() {
    var _this;

    _classCallCheck(this, CodePreview);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.demoDom = React.createRef();
    _this.editor = React.createRef();
    _this.language = '';
    _this.initHeight = 3;
    _this.playerId = "".concat(parseInt(String(Math.random() * 1e9), 10).toString(36));
    _this.state = {
      errorMessage: '',
      fullScreen: false,
      copied: false,
      showEdit: false,
      width: 1
    };
    return _this;
  }

  _createClass(CodePreview, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var language = this.props.language;
      this.language = typeof language === 'string' ? language : language ? language.name || '' : '';

      if (!this.props.noPreview) {
        this.executeCode(this.props.code);
      }

      window.addEventListener("popstate", function (e) {
        document.body.style.overflow = 'inherit';
      }, false);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var language = nextProps.language;
      this.language = typeof language === 'string' ? language : language ? language.name || '' : '';

      if (nextProps.noPreview !== this.props.noPreview) {
        this.executeCode(this.props.code);
      }
    }
  }, {
    key: "executeCode",
    value: function () {
      var _executeCode = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee(codeStr) {
        var args, argv, Elm, _key2, input, _ref, code, message;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (/(jsx|js)/.test(this.language)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                _context.prev = 2;
                args = ['context', 'React', 'ReactDOM', 'Component'];
                argv = [this, React, ReactDOM, Component];
                Elm = this.props.dependencies;

                for (_key2 in Elm) {
                  args.push(_key2);
                  argv.push(Elm[_key2]);
                }

                codeStr = codeStr.replace('_mount_', "document.getElementById('".concat(this.playerId, "')"));
                input = "".concat(codeStr);
                _context.next = 11;
                return BabelTransform(input);

              case 11:
                _ref = _context.sent;
                code = _ref.code;
                args.push(code); // eslint-disable-next-line no-new-func

                _construct(Function, args).apply(null, argv);

                this.setState({
                  errorMessage: ''
                });
                _context.next = 23;
                break;

              case 18:
                _context.prev = 18;
                _context.t0 = _context["catch"](2);
                message = '';

                if (_context.t0 && _context.t0.message) {
                  message = _context.t0.message;
                } else {
                  message = JSON.stringify(_context.t0);
                }

                this.setState({
                  errorMessage: message
                });

              case 23:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[2, 18]]);
      }));

      function executeCode(_x) {
        return _executeCode.apply(this, arguments);
      }

      return executeCode;
    }()
    /**
     * onCopyCode
     */

  }, {
    key: "onCopyCode",
    value: function onCopyCode() {
      var _this2 = this;

      var code = this.props.code;
      copyTextToClipboard(code || '', function (isCopy) {
        _this2.setState({
          copied: isCopy
        });
      });
      setTimeout(function () {
        _this2.setState({
          copied: false
        });
      }, 2000);
    }
    /**
     * onFullScreen
     */

  }, {
    key: "onFullScreen",
    value: function onFullScreen() {
      var _this3 = this;

      var fullScreen = this.state.fullScreen;
      this.setState({
        fullScreen: !fullScreen
      }, function () {
        document.body.style.overflow = !fullScreen ? 'hidden' : 'inherit';

        if (!fullScreen && _this3.demoDom.current) {
          _this3.demoDom.current.style.maxWidth = 'inherit';
        }
      });
    }
  }, {
    key: "initOldHeight",
    value: function initOldHeight() {
      var demo = this.demoDom.current;

      if (this.initHeight === 3 && demo) {
        this.initHeight = demo.clientHeight;
      }
    }
    /**
     * onSwitchSource
     */

  }, {
    key: "onSwitchSource",
    value: function onSwitchSource() {
      var _this4 = this;

      var width = this.state.width;
      this.initOldHeight();
      this.setState({
        width: width === 1 ? '50%' : 1,
        showEdit: true
      }, function () {
        var editor = _this4.editor.current;

        if (editor) {
          editor.editor.setSize('100%', width !== 1 ? _this4.initHeight : '100%');
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames,
          _classnames2,
          _this5 = this;

      var _this$props = this.props,
          style = _this$props.style,
          prefixCls = _this$props.prefixCls,
          language = _this$props.language,
          className = _this$props.className,
          editProps = _this$props.editProps,
          codePenOption = _this$props.codePenOption,
          code = _this$props.code,
          dependencies = _this$props.dependencies,
          onlyEdit = _this$props.onlyEdit,
          bordered = _this$props.bordered,
          noCode = _this$props.noCode,
          noPreview = _this$props.noPreview,
          noScroll = _this$props.noScroll,
          bgWhite = _this$props.bgWhite,
          otherProps = _objectWithoutProperties(_this$props, ["style", "prefixCls", "language", "className", "editProps", "codePenOption", "code", "dependencies", "onlyEdit", "bordered", "noCode", "noPreview", "noScroll", "bgWhite"]);

      var isOneItem = !noCode && !noPreview ? false : !noCode || !noPreview;
      var visiable = this.state.width === 1 ? false : [isOneItem ? 1 : 2];
      return (
        /*#__PURE__*/
        React.createElement(Split, _extends({
          visiable: visiable,
          className: classnames(className, prefixCls, (_classnames = {}, _defineProperty(_classnames, "".concat(prefixCls, "-noScroll"), noScroll), _defineProperty(_classnames, "".concat(prefixCls, "-OneItem"), isOneItem), _defineProperty(_classnames, "".concat(prefixCls, "-bordered"), bordered), _defineProperty(_classnames, "".concat(prefixCls, "-fullScreen"), this.state.fullScreen), _classnames)),
          style: _objectSpread({
            flex: 1
          }, style)
        }, otherProps), !noPreview && !onlyEdit &&
        /*#__PURE__*/
        React.createElement("div", {
          ref: this.demoDom,
          className: classnames("".concat(prefixCls, "-demo"), (_classnames2 = {}, _defineProperty(_classnames2, "".concat(prefixCls, "-demo-bgPlaid"), !bgWhite), _defineProperty(_classnames2, "".concat(prefixCls, "-demo-error"), this.state.errorMessage), _classnames2)),
          style: _objectSpread({
            flex: 1
          }, this.state.width === 1 ? {
            width: '100%'
          } : {})
        }, this.state.errorMessage &&
        /*#__PURE__*/
        React.createElement("pre", null,
        /*#__PURE__*/
        React.createElement("code", null, this.state.errorMessage)),
        /*#__PURE__*/
        React.createElement("div", {
          className: classnames("".concat(prefixCls, "-demo-source"), {
            'error': this.state.errorMessage
          }),
          id: this.playerId
        })), (!noCode || onlyEdit) &&
        /*#__PURE__*/
        React.createElement("div", {
          style: {
            overflow: 'hidden',
            width: onlyEdit ? '100%' : this.state.width
          }
        }, (this.state.showEdit || onlyEdit) &&
        /*#__PURE__*/
        React.createElement(CodeMirror, _extends({
          value: (code || '').replace(/\n$/, ''),
          ref: this.editor,
          options: {
            theme: 'monokai',
            mode: language
          }
        }, editProps, {
          onChange: function onChange(editor) {
            _this5.executeCode(editor.getValue());
          }
        }))), !isOneItem && !(noCode && noPreview) && !onlyEdit &&
        /*#__PURE__*/
        React.createElement("div", {
          style: {
            flex: 1,
            width: 29
          },
          className: "".concat(prefixCls, "-bar")
        }, codePenOption &&
        /*#__PURE__*/
        React.createElement(CodePen, {
          prefixCls: prefixCls,
          options: codePenOption
        }),
        /*#__PURE__*/
        React.createElement("div", {
          className: "".concat(prefixCls, "-bar-btn"),
          onClick: this.onSwitchSource.bind(this)
        }, this.state.width === 1 ? '源码' : '隐藏编辑器'),
        /*#__PURE__*/
        React.createElement("div", {
          className: classnames("".concat(prefixCls, "-bar-iconbtns"), _defineProperty({}, "".concat(prefixCls, "-bar-copied"), this.state.copied)),
          onClick: this.onCopyCode.bind(this)
        }, icon.copy),
        /*#__PURE__*/
        React.createElement("div", {
          className: classnames("".concat(prefixCls, "-bar-iconbtns"), _defineProperty({}, "".concat(prefixCls, "-bar-copied"), this.state.fullScreen)),
          onClick: this.onFullScreen.bind(this)
        }, icon.full)))
      );
    }
  }]);

  return CodePreview;
}(React.PureComponent);

CodePreview.defaultProps = {
  prefixCls: 'w-code-preview',
  language: 'jsx',
  code: '',
  editProps: {},
  noCode: false,
  bgWhite: false,
  onlyEdit: false,
  noPreview: false,
  bordered: true
};
export { CodePreview as default }; 
//# sourceMappingURL=index.js.map